This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
no 5.9.4; should fail in version 5.9.4.
[perl5.git] / t / comp / use.t
1 #!./perl
2
3 BEGIN {
4     chdir 't' if -d 't';
5     @INC = '../lib';
6 }
7
8 print "1..59\n";
9
10 # Can't require test.pl, as we're testing the use/require mechanism here.
11
12 my $test = 1;
13
14 sub _ok {
15     my ($type, $got, $expected, $name) = @_;
16
17     my $result;
18     if ($type eq 'is') {
19         $result = $got eq $expected;
20     } elsif ($type eq 'isnt') {
21         $result = $got ne $expected;
22     } elsif ($type eq 'like') {
23         $result = $got =~ $expected;
24     } else {
25         die "Unexpected type '$type'$name";
26     }
27     if ($result) {
28         if ($name) {
29             print "ok $test - $name\n";
30         } else {
31             print "ok $test\n";
32         }
33     } else {
34         if ($name) {
35             print "not ok $test - $name\n";
36         } else {
37             print "not ok $test\n";
38         }
39         my @caller = caller(2);
40         print "# Failed test at $caller[1] line $caller[2]\n";
41         print "# Got      '$got'\n";
42         if ($type eq 'is') {
43             print "# Expected '$expected'\n";
44         } elsif ($type eq 'isnt') {
45             print "# Expected not '$expected'\n";
46         } elsif ($type eq 'like') {
47             print "# Expected $expected\n";
48         }
49     }
50     $test = $test + 1;
51     $result;
52 }
53
54 sub like ($$;$) {
55     _ok ('like', @_);
56 }
57 sub is ($$;$) {
58     _ok ('is', @_);
59 }
60 sub isnt ($$;$) {
61     _ok ('isnt', @_);
62 }
63
64 eval "use 5.000";       # implicit semicolon
65 is ($@, '');
66
67 eval "use 5.000;";
68 is ($@, '');
69
70 eval "use 6.000;";
71 like ($@, qr/Perl v6\.0\.0 required--this is only \Q$^V\E, stopped/);
72
73 eval "no 6.000;";
74 is ($@, '');
75
76 eval "no 5.000;";
77 like ($@, qr/Perls since v5\.0\.0 too modern--this is \Q$^V\E, stopped/);
78
79 eval sprintf "use %.6f;", $];
80 is ($@, '');
81
82
83 eval sprintf "use %.6f;", $] - 0.000001;
84 is ($@, '');
85
86 eval sprintf("use %.6f;", $] + 1);
87 like ($@, qr/Perl v6.\d+.\d+ required--this is only \Q$^V\E, stopped/);
88
89 eval sprintf "use %.6f;", $] + 0.00001;
90 like ($@, qr/Perl v5.\d+.\d+ required--this is only \Q$^V\E, stopped/);
91
92 { use lib }     # check that subparse saves pending tokens
93
94 local $lib::VERSION = 1.0;
95
96 eval "use lib 0.9";
97 is ($@, '');
98
99 eval "use lib 1.0";
100 is ($@, '');
101
102 eval "use lib 1.01";
103 isnt ($@, '');
104
105
106 eval "use lib 0.9 qw(fred)";
107 is ($@, '');
108
109 if ($^O eq 'MacOS') {
110     is($INC[0], ":fred:");
111 } else {
112     is($INC[0], "fred");
113 }
114
115 eval "use lib 1.0 qw(joe)";
116 is ($@, '');
117
118
119 if ($^O eq 'MacOS') {
120     is($INC[0], ":joe:");
121 } else {
122     is($INC[0], "joe");
123 }
124
125
126 eval "use lib 1.01 qw(freda)";
127 isnt($@, '');
128
129 if ($^O eq 'MacOS') {
130     isnt($INC[0], ":freda:");
131 } else {
132     isnt($INC[0], "freda");
133 }
134
135 {
136     local $lib::VERSION = 35.36;
137     eval "use lib v33.55";
138     is ($@, '');
139
140     eval "use lib v100.105";
141     like ($@, qr/lib version 100.105 \(v100\.105\.0\) required--this is only version 35.360 \(v35\.360\.0\)/);
142
143     eval "use lib 33.55";
144     is ($@, '');
145
146     eval "use lib 100.105";
147     like ($@, qr/lib version 100.105 \(v100\.105\.0\) required--this is only version 35.360 \(v35\.360\.0\)/);
148
149     local $lib::VERSION = '35.36';
150     eval "use lib v33.55";
151     like ($@, '');
152
153     eval "use lib v100.105";
154     like ($@, qr/lib version 100.105 \(v100\.105\.0\) required--this is only version 35.360 \(v35\.360\.0\)/);
155
156     eval "use lib 33.55";
157     is ($@, '');
158
159     eval "use lib 100.105";
160     like ($@, qr/lib version 100.105 \(v100\.105\.0\) required--this is only version 35.360 \(v35\.360\.0\)/);
161
162     local $lib::VERSION = v35.36;
163     eval "use lib v33.55";
164     is ($@, '');
165
166     eval "use lib v100.105";
167     like ($@, qr/lib version 100.105 \(v100\.105\.0\) required--this is only version 35.036000 \(v35\.36\.0\)/);
168
169     eval "use lib 33.55";
170     is ($@, '');
171
172     eval "use lib 100.105";
173     like ($@, qr/lib version 100.105 \(v100\.105\.0\) required--this is only version 35.036000 \(v35\.36\.0\)/);
174 }
175
176
177 {
178     # Regression test for patch 14937: 
179     #   Check that a .pm file with no package or VERSION doesn't core.
180     open F, ">xxx.pm" or die "Cannot open xxx.pm: $!\n";
181     print F "1;\n";
182     close F;
183     eval "use lib '.'; use xxx 3;";
184     like ($@, qr/^xxx defines neither package nor VERSION--version check failed at/);
185     unlink 'xxx.pm';
186 }
187
188 my @ver = split /\./, sprintf "%vd", $^V;
189
190 foreach my $index (-3..+3) {
191     foreach my $v (0, 1) {
192         my @parts = @ver;
193         if ($index) {
194             if ($index < 0) {
195                 # Jiggle one of the parts down
196                 --$parts[-$index - 1];
197             } else {
198                 # Jiggle one of the parts up
199                 ++$parts[$index - 1];
200             }
201         }
202         my $v_version = sprintf "v%d.%d.%d", @parts;
203         my $version;
204         if ($v) {
205             $version = $v_version;
206         } else {
207             $version = $parts[0] + $parts[1] / 1000 + $parts[2] / 1000000;
208         }
209
210         eval "use $version";
211         if ($index > 0) {
212             # The future
213             like ($@,
214                   qr/Perl $v_version required--this is only \Q$^V\E, stopped/,
215                   "use $version");
216         } else {
217             # The present or past
218             is ($@, '', "use $version");
219         }
220
221         eval "no $version";
222         if ($index <= 0) {
223             # The present or past
224             like ($@,
225                   qr/Perls since $v_version too modern--this is \Q$^V\E, stopped/,
226                   "no $version");
227         } else {
228             # future
229             is ($@, '', "no $version");
230         }
231     }
232 }
233